#!/bin/sh

# Main settings:
#   * BOOTSTRAP_HASKELL_NONINTERACTIVE - any nonzero value for noninteractive installation
#   * BOOTSTRAP_HASKELL_NO_UPGRADE - any nonzero value to not trigger the upgrade
#   * GHCUP_USE_XDG_DIRS - any nonzero value to respect The XDG Base Directory Specification
#   * BOOTSTRAP_HASKELL_VERBOSE - any nonzero value for more verbose installation
#   * BOOTSTRAP_HASKELL_GHC_VERSION
#   * BOOTSTRAP_HASKELL_CABAL_VERSION

# License: LGPL-3.0


# safety subshell to avoid executing anything in case this script is not downloaded properly
(

: "${GHCUP_INSTALL_BASE_PREFIX:=$HOME}"

export GHCUP_USE_XDG_DIRS

if [ -n "${GHCUP_USE_XDG_DIRS}" ] ; then
	GHCUP_DIR=${XDG_DATA_HOME:=$HOME/.local/share}/ghcup
	GHCUP_BIN=${XDG_BIN_HOME:=$HOME/.local/bin}
else
	GHCUP_DIR=${GHCUP_INSTALL_BASE_PREFIX}/.ghcup
	GHCUP_BIN=${GHCUP_INSTALL_BASE_PREFIX}/.ghcup/bin
fi

: "${BOOTSTRAP_HASKELL_GHC_VERSION:=recommended}"
: "${BOOTSTRAP_HASKELL_CABAL_VERSION:=recommended}"

die() {
    (>&2 printf "\\033[0;31m%s\\033[0m\\n" "$1")
    exit 2
}

edo() {
    "$@" || die "\"$*\" failed!"
}

eghcup() {
	edo _eghcup "$@"
}

_eghcup() {
    if [ -z "${BOOTSTRAP_HASKELL_VERBOSE}" ] ; then
        ghcup "$@"
    else
        ghcup --verbose "$@"
    fi
}

_done() {
	echo
    echo "All done!"
	echo
	echo "To start a simple repl, run:"
	echo "  ghci"
	echo
	echo "To start a new haskell project in the current directory, run:"
	echo "  cabal init --interactive"
	echo
	echo "To install other GHC versions, run:"
	echo "  ghcup tui"

	exit 0
}

download_ghcup() {
	_plat="$(uname -s)"
	_arch=$(uname -m)
	_ghver="0.1.12"
	_base_url="https://downloads.haskell.org/~ghcup"

    case "${_plat}" in
        "linux"|"Linux")
			case "${_arch}" in
				x86_64|amd64)
					# we could be in a 32bit docker container, in which
					# case uname doesn't give us what we want
					if [ "$(getconf LONG_BIT)" = "32" ] ; then
						_url=${_base_url}/${_ghver}/i386-linux-ghcup-${_ghver}
					elif [ "$(getconf LONG_BIT)" = "64" ] ; then
						_url=${_base_url}/${_ghver}/x86_64-linux-ghcup-${_ghver}
					else
						die "Unknown long bit size: $(getconf LONG_BIT)"
					fi
					;;
				i*86)
					_url=${_base_url}/${_ghver}/i386-linux-ghcup-${_ghver}
					;;
				*) die "Unknown architecture: ${_arch}"
					;;
			esac
			;;
        "FreeBSD"|"freebsd")
			case "${_arch}" in
				x86_64|amd64)
					;;
				i*86)
					die "i386 currently not supported!"
					;;
				*) die "Unknown architecture: ${_arch}"
					;;
			esac
			_url=${_base_url}/${_ghver}/x86_64-portbld-freebsd-ghcup-${_ghver}
            ;;
        "Darwin"|"darwin")
			case "${_arch}" in
				x86_64|amd64)
					;;
				i*86)
					die "i386 currently not supported!"
					;;
				*) die "Unknown architecture: ${_arch}"
					;;
			esac
			_url=${_base_url}/${_ghver}/x86_64-apple-darwin-ghcup-${_ghver} ;;
        *) die "Unknown platform: ${_plat}"
			;;
    esac

	edo curl -Lf "${_url}" > "${GHCUP_BIN}"/ghcup

    edo chmod +x "${GHCUP_BIN}"/ghcup

  edo mkdir -p "${GHCUP_DIR}"
	cat <<-EOF > "${GHCUP_DIR}"/env || die "Failed to create env file"
		export PATH="\$HOME/.cabal/bin:${GHCUP_BIN}:\$PATH"
		EOF
	# shellcheck disable=SC1090
    edo . "${GHCUP_DIR}"/env
    eghcup upgrade

	unset _plat _arch _url _ghver _base_url
}


echo
echo "Welcome to Haskell!"
echo
echo "This script will download and install the following binaries:"
echo "  * ghcup - The Haskell toolchain installer"
echo "            (for managing GHC/cabal versions)"
echo "  * ghc   - The Glasgow Haskell Compiler"
echo "  * cabal - The Cabal build tool"
echo
if [ -z "${GHCUP_USE_XDG_DIRS}" ] ; then
	echo "ghcup installs only into the following directory,"
    echo "which can be removed anytime:"
	echo "  $GHCUP_INSTALL_BASE_PREFIX/.ghcup"
else
	echo "ghcup installs into XDG directories as long as"
    echo "'GHCUP_USE_XDG_DIRS' is set."
fi
echo

if [ -z "${BOOTSTRAP_HASKELL_NONINTERACTIVE}" ] ; then
    printf "\\033[0;35m%s\\033[0m\\n" "Press ENTER to proceed or ctrl-c to abort."
    printf "\\033[0;35m%s\\033[0m\\n" "Note that this script can be re-run at any given time."
    echo
    # Wait for user input to continue.
    # shellcheck disable=SC2034
    read -r answer </dev/tty
fi

edo mkdir -p "${GHCUP_BIN}"

if command -V "ghcup" >/dev/null 2>&1 ; then
    if [ -z "${BOOTSTRAP_HASKELL_NO_UPGRADE}" ] ; then
        _eghcup upgrade || download_ghcup
    fi
else
	download_ghcup
fi

echo
echo "$(ghcup tool-requirements)"
echo

if [ -z "${BOOTSTRAP_HASKELL_NONINTERACTIVE}" ] ; then
    printf "\\033[0;35m%s\\033[0m\\n" "Press ENTER to proceed or ctrl-c to abort."
    printf "\\033[0;35m%s\\033[0m\\n" "Installation may take a while."
    echo

    # Wait for user input to continue.
    # shellcheck disable=SC2034
    read -r answer </dev/tty
fi

eghcup --cache install ghc "${BOOTSTRAP_HASKELL_GHC_VERSION}"

eghcup set ghc "${BOOTSTRAP_HASKELL_GHC_VERSION}"
eghcup --cache install cabal "${BOOTSTRAP_HASKELL_CABAL_VERSION}"

edo cabal new-update

printf "\\033[0;35m%s\\033[0m\\n" ""
printf "\\033[0;35m%s\\033[0m\\n" "Installation done!"
printf "\\033[0;35m%s\\033[0m\\n" ""


if [ -z "${BOOTSTRAP_HASKELL_NONINTERACTIVE}" ] ; then
	printf "\\033[0;35m%s\\033[0m\\n" "Do you want to install haskell-language-server (HLS) now?"
	printf "\\033[0;35m%s\\033[0m\\n" "HLS is a language-server that provides IDE-like functionality"
	printf "\\033[0;35m%s\\033[0m\\n" "and can integrate with different editors, such as Vim, Emacs, VS Code, Atom, ..."
	printf "\\033[0;35m%s\\033[0m\\n" "Also see https://github.com/haskell/haskell-language-server/blob/master/README.md"
	printf "\\033[0;35m%s\\033[0m\\n" ""
	printf "\\033[0;35m%s\\033[0m\\n" "Answer with YES or NO and press ENTER."
	printf "\\033[0;35m%s\\033[0m\\n" ""

	while true; do
		read -r hls_answer </dev/tty

		case $hls_answer in
			[Yy]*)
				eghcup --cache install hls
				break ;;
			[Nn]*)
				break ;;
			*)
				echo "Please type YES or NO and press enter.";;
		esac
	done

    echo "In order to run ghc and cabal, you need to adjust your PATH variable."
    echo "You may want to source '$GHCUP_DIR/env' in your shell"
    echo "configuration to do so (e.g. ~/.bashrc)."

	case $SHELL in
		*/zsh) # login shell is zsh
			GHCUP_PROFILE_FILE="$HOME/.zshrc"
			MY_SHELL="zsh" ;;
		*/bash) # login shell is bash
			GHCUP_PROFILE_FILE="$HOME/.bashrc"
			MY_SHELL="bash" ;;
		*/sh) # login shell is sh, but might be a symlink to bash or zsh
			if [ -n "${BASH}" ] ; then
				GHCUP_PROFILE_FILE="$HOME/.bashrc"
				MY_SHELL="bash"
			elif [ -n "${ZSH_VERSION}" ] ; then
				GHCUP_PROFILE_FILE="$HOME/.zshrc"
				MY_SHELL="zsh"
			else
			    _done
			fi
			;;
		*/fish) # login shell is fish
			GHCUP_PROFILE_FILE="$HOME/.config/fish/config.fish"
			MY_SHELL="fish" ;;
		*) _done ;;
	esac


	printf "\\033[0;35m%s\\033[0m\\n" ""
	printf "\\033[0;35m%s\\033[0m\\n" "Detected ${MY_SHELL} shell on your system..."
	printf "\\033[0;35m%s\\033[0m\\n" "If you want ghcup to automatically add the required PATH variable to \"${GHCUP_PROFILE_FILE}\""
	printf "\\033[0;35m%s\\033[0m\\n" "answer with YES, otherwise with NO and press ENTER."
	printf "\\033[0;35m%s\\033[0m\\n" ""

    while true; do
        read -r next_answer </dev/tty

        case $next_answer in
            [Yy]*)
				case $MY_SHELL in
					"") break ;;
					fish)
						if ! grep -q "ghcup-env" "${GHCUP_PROFILE_FILE}" ; then
							echo "# ghcup-env" >> "${GHCUP_PROFILE_FILE}"
							echo "set -q GHCUP_INSTALL_BASE_PREFIX[1]; or set GHCUP_INSTALL_BASE_PREFIX \$HOME" >> "${GHCUP_PROFILE_FILE}"
							echo "test -f $GHCUP_DIR/env ; and set -gx PATH \$HOME/.cabal/bin $GHCUP_BIN \$PATH" >> "${GHCUP_PROFILE_FILE}"
						fi
						break ;;
					bash)
						if ! grep -q "ghcup-env" "${GHCUP_PROFILE_FILE}" ; then
							echo "[ -f \"${GHCUP_DIR}/env\" ] && source \"${GHCUP_DIR}/env\" # ghcup-env" >> "${GHCUP_PROFILE_FILE}"
						fi
						case "$(uname -s)" in
							"Darwin"|"darwin")
								if ! grep -q "ghcup-env" "${HOME}/.bash_profile" ; then
									echo "[[ -f ~/.bashrc ]] && source ~/.bashrc # ghcup-env" >> "${HOME}/.bash_profile"
								fi
								;;
						esac
						break ;;

					zsh)
						if ! grep -q "ghcup-env" "${GHCUP_PROFILE_FILE}" ; then
							echo "[ -f \"${GHCUP_DIR}/env\" ] && source \"${GHCUP_DIR}/env\" # ghcup-env" >> "${GHCUP_PROFILE_FILE}"
						fi
						break ;;
				esac
                printf "\\033[0;35m%s\\033[0m\\n" "OK! ${GHCUP_PROFILE_FILE} has been modified. Restart your terminal for the changes to take effect,"
                printf "\\033[0;35m%s\\033[0m\\n" "or type \"source ${GHCUP_DIR}/env\" to apply them in your current terminal session."
				_done
                ;;
            [Nn]*)
                _done ;;
            *)
                echo "Please type YES or NO and press enter.";;
        esac
    done
fi
)

# vim: tabstop=4 shiftwidth=4 expandtab